> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Run materialization for a data model element

POST https://api.sigmacomputing.com/v2/dataModels/{dataModelId}:materialize
Content-Type: application/json

This endpoint runs a scheduled materialization for an element in a data model. Materialization processes the data of the specified element, allowing the data to be stored or cached for optimized access and performance.

  For more details on materialization, see [Materialization](https://help.sigmacomputing.com/docs/materialization).

  ### Usage notes
  - The materialization schedule for the specified element must be created beforehand.
  - Retrieve the **sheetId** by calling the [/v2/dataModels/{dataModelId}/materialization-schedules](https://help.sigmacomputing.com/reference/list-data-model-materialization-schedules) endpoint.
  - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

  ### Usage scenarios
  - **Performance optimization:** Use this endpoint to improve response times for frequently accessed data model elements.
  - **Data refresh:** Allows users to manually (programmatically) refresh the data of specific data model elements to ensure that the latest data is available for analysis and reporting.

  ### Best practices
  - Prioritize materialization for elements that are heavily used or form critical components of business reports.
  - Monitor the performance impacts of materialization and adjust strategies as necessary to optimize resource usage and response times.

Reference: https://help.sigmacomputing.com/reference/materialize-data-model-element

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/dataModels/{dataModelId}:materialize:
    post:
      operationId: materializeDataModelElement
      summary: Run materialization for a data model element
      description: >-
        This endpoint runs a scheduled materialization for an element in a data
        model. Materialization processes the data of the specified element,
        allowing the data to be stored or cached for optimized access and
        performance.

          For more details on materialization, see [Materialization](https://help.sigmacomputing.com/docs/materialization).

          ### Usage notes
          - The materialization schedule for the specified element must be created beforehand.
          - Retrieve the **sheetId** by calling the [/v2/dataModels/{dataModelId}/materialization-schedules](https://help.sigmacomputing.com/reference/list-data-model-materialization-schedules) endpoint.
          - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

          ### Usage scenarios
          - **Performance optimization:** Use this endpoint to improve response times for frequently accessed data model elements.
          - **Data refresh:** Allows users to manually (programmatically) refresh the data of specific data model elements to ensure that the latest data is available for analysis and reporting.

          ### Best practices
          - Prioritize materialization for elements that are heavily used or form critical components of business reports.
          - Monitor the performance impacts of materialization and adjust strategies as necessary to optimize resource usage and response times.
      tags:
        - dataModels
      parameters:
        - name: dataModelId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/dataModels_materializeDataModelElement_Response_200
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                sheetId:
                  type: string
                  description: Identifier for the materialization schedule of this element.
              required:
                - sheetId
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    dataModels_materializeDataModelElement_Response_200:
      type: object
      properties:
        materializationId:
          type: string
      required:
        - materializationId
      title: dataModels_materializeDataModelElement_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{
  "sheetId": "sheet_987654321"
}
```

**Response**

```json
{
  "materializationId": "mat_123e4567-e89b-12d3-a456-426614174000"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize"

payload = { "sheetId": "sheet_987654321" }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"sheetId":"sheet_987654321"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize"

	payload := strings.NewReader("{\n  \"sheetId\": \"sheet_987654321\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"sheetId\": \"sheet_987654321\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"sheetId\": \"sheet_987654321\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize', [
  'body' => '{
  "sheetId": "sheet_987654321"
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"sheetId\": \"sheet_987654321\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["sheetId": "sheet_987654321"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId:materialize")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```